#include <string.h>
#include <alloc.h>
#include <stdarg.h>
#include <dos.h>
#include <iostream.h>
#include <conio.h>
#include <stdio.h>
#include <ctype.h>
#include <process.h>

#define VGA_INPUT_STATUS_1 0x3DA
#define VGA_VSYNC_MASK 0x08

void WaitForVsync(void){
	while(inp(VGA_INPUT_STATUS_1) & VGA_VSYNC_MASK);
	while(!(inp(VGA_INPUT_STATUS_1) & VGA_VSYNC_MASK));
}


enum {
GAMESTART,
SHOWLOGO,
LOGO,
SHOWTOWN,
TOWN,
SHOWMAINMENU,
MAINMENU,
SHOWMAINMAP,
MAINMAP,
SHOWFIGHT,
FIGHT,
SHOWSETUPMENU,
SETUPMENU
};

	struct CurrentMapPage {
		int x;
		int y;         //Which map page you're on
		int oldx;  //old x and y
		int oldy;
	};
	CurrentMapPage CurrentPage;

	struct Player {  //the player characters
		char *name;
		int hp;
		int mp;
		int turn;
	};
	Player Player1;
	Player Player2;
	Player Player3;
	Player Player4;

	struct UserInfo {  //THE USER!!@@(*^#(%*&
		int oldx; //X location of the map when you're in a town, cave, etc
		int oldy; //Y location of the map when you're in a town, cave, etc.
		int x;   //X location of the map
		int y;   //Y location of the map
		int gold; //how much gold the party has
	};
	UserInfo User;

char Map[26][81];  //Map loading is screwed, so y is before x


//Function Declarations
void ShowLogoScreen();  //displays the logo screen
void ShowMainMenu();  //displays the main menu
void ShowIntroduction();  //displays the introduction
void ShowCredits();  //displays the credits
void ColorCode(char tempchar, int x, int y);  //color codes a character.  see function for more info
void LoadMap(char *Filename); //loads a map into memory
void DisplayMap();  //displays a map on the screen after it has been loaded into memory with LoadMap();

int MainMenuKeyStatus=0; //shows where the cursor is in the mainmenu
int StatusMenuKeyStatus=0;
int NoClipping=0;  //whether or not the user is affected by what type of land is on the screen..

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=- main -=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//hmm...main?
int main()
{
	textbackground(0);
	clrscr();  //clear the screen first thing

//****Initialization of main variables****\\
	int Status;  //the message mapper
	Status=GAMESTART; //starts you off at the beginning of the game
	char keytemp;  //temp varaible that holds temporary key presses
	int Quit; //makes the program exit after the current function is over
	char *CurrentMap;
	CurrentPage.x=0;
	CurrentPage.y=0;
	CurrentMap="MAP00.DAT";
	Quit=0;
	User.x=10;
	User.y=5;
	User.oldx=10;
	User.oldy=5;
	User.gold=200;
	Player1.name="Player1";
	Player2.name="Player2";
	Player3.name="Player3";
	Player4.name="Player4";
	Player1.hp=50;
	Player1.mp=50;
	Player2.hp=50;
	Player2.mp=50;
	Player3.hp=50;
	Player3.mp=50;
	Player4.hp=50;
	Player4.mp=50;


//****Beginning of main program/message handler****\\
	while(Quit==0)
	{

			_setcursortype(_NORMALCURSOR);  //set it to a normal cursor for the main menu

			switch(Status)
			{
			case GAMESTART:
				ShowLogoScreen();
				Status=LOGO;
				break;
			case LOGO:
				ShowMainMenu();
				Status=MAINMENU;
				break;
			case SHOWMAINMAP:
				LoadMap(CurrentMap);
				DisplayMap();
				Status=MAINMAP;
				break;
			case SHOWSETUPMENU:
				LoadMap("SETUP1.DAT");
				DisplayMap();
				Status=SETUPMENU;
				break;
			case SETUPMENU:
				_setcursortype(_NOCURSOR);
				textcolor(15);
				textbackground(0);
				gotoxy(65,3);
				textcolor(9);
				cprintf("+-=I");
				textcolor(7);
				cprintf("tems=---+");
				gotoxy(65,4);
				textcolor(9);
				cprintf("+-=S");
				textcolor(7);
				cprintf("kills=--+");
				gotoxy(65,5);
				textcolor(9);
				cprintf("+-=E");
				textcolor(7);
				cprintf("quip=---+");
				gotoxy(65,6);
				textcolor(9);
				cprintf("+-=S");
				textcolor(7);
				cprintf("tatus=--+");
				gotoxy(65,7);
				textcolor(9);
				cprintf("+-=C");
				textcolor(7);
				cprintf("onfig=--+");
				gotoxy(65,8);
				textcolor(9);
				cprintf("+-=S");
				textcolor(7);
				cprintf("ave=----+");
				gotoxy(65,9);
				textcolor(9);
				cprintf("+-=Q");
				textcolor(7);
				cprintf("uit=----+");
				textcolor(15);
				gotoxy(33,24);
				cprintf("Press ESC for Map ");

				gotoxy(66,3+StatusMenuKeyStatus);
				_setcursortype(_NORMALCURSOR);  //set it to a normal cursor for the main menu
/*				while(!kbhit())  //wait until the user presses a key
				{
				}*/
				keytemp=getch();  //get the key pressed into a variable
				keytemp=toupper(keytemp); //turn the key pressed into uppercase
				switch(keytemp)
				{
				case 27:  //handles the ESC key
					sprintf(CurrentMap,"MAP%i%i.DAT",CurrentPage.oldx,CurrentPage.oldy);
					LoadMap(CurrentMap);
					DisplayMap();
					Status=MAINMAP;
					break;
				case 13:  //handles the enter key
					switch(StatusMenuKeyStatus)
					{
					case 0: //this is the items button
//						Status=SHOWMAINMAP;
						break;
					case 1: //This is the skills button
//						ShowIntroduction();
//						ShowMainMenu();
						break;
					case 2: //This is the equip button
//						ShowCredits();
//						ShowMainMenu();
						break;
					case 3: //this is the status Button
//						Quit=1;  //quits the game promptly :)
						break;
					case 4: //This is the config button
//						ShowCredits();
//						ShowMainMenu();
						break;
					case 5: //This is the save button
//						ShowCredits();
//						ShowMainMenu();
//						Status=MAINMENU;
						break;
					case 6: //This is the quit button
						ShowMainMenu();
						Status=MAINMENU;
						break;
					}
					case 0:  //trap the extended character set (for arrow keys)
						keytemp=getch();
						switch(keytemp)
						{
							case 'P':  //down arrow key
								if(StatusMenuKeyStatus<6)
								{
									StatusMenuKeyStatus=StatusMenuKeyStatus++;
									gotoxy(66,3+StatusMenuKeyStatus);
								}
								break;
							case 'H': //up arrow key
								if(StatusMenuKeyStatus>0)
								{
									StatusMenuKeyStatus=StatusMenuKeyStatus--;
									gotoxy(66,3+StatusMenuKeyStatus);
								}
								break;
						}
					}
					break;
			case SHOWFIGHT:
				CurrentPage.oldx=CurrentPage.x;
				CurrentPage.oldy=CurrentPage.y;
				User.oldx=User.x;
				User.oldy=User.y;
				LoadMap("FIGHT1.DAT");
				DisplayMap();
				Status=FIGHT;
				break;
			case FIGHT:
				_setcursortype(_NOCURSOR);
				textcolor(15);
				textbackground(0);
				gotoxy(60,3);
				cprintf("%s  -  %i/%i",Player1.name,Player1.hp,Player1.mp);
				gotoxy(60,5);
				cprintf("%s  -  %i/%i",Player2.name,Player2.hp,Player2.mp);
				gotoxy(60,7);
				cprintf("%s  -  %i/%i",Player3.name,Player3.hp,Player3.mp);
				gotoxy(60,9);
				cprintf("%s  -  %i/%i",Player4.name,Player4.hp,Player4.mp);
				while(!kbhit())
				{
				}
				keytemp=getch();
				keytemp=toupper(keytemp);
				switch(keytemp)
				{
				case 27:  //handles the ESC key
					sprintf(CurrentMap,"MAP%i%i.DAT",CurrentPage.oldx,CurrentPage.oldy);
					LoadMap(CurrentMap);
					CurrentPage.x=CurrentPage.oldx;
					CurrentPage.y=CurrentPage.oldy;
					User.x=User.oldx;
					User.y=User.oldy;
					DisplayMap();
					Status=MAINMAP;
					break;
				}
				break;
			case SHOWTOWN:
				break;
			case TOWN:
				break;
			case MAINMAP:
				_setcursortype(_NOCURSOR);
				textbackground(0);
				textcolor(15);
				gotoxy(5,21);   //prints out info
				cprintf("Current Map Page: (%i,%i)",CurrentPage.x,CurrentPage.y);
				gotoxy(5,21);   //prints out info
				cprintf("C"); //for some reason or another it likes to print an S for the first character displayed in this function :P  heh..whatever
				gotoxy(5,22);
				cprintf("HP: %i/%i/%i/%i",Player1.hp,Player2.hp,Player3.hp,Player4.hp);
				gotoxy(5,23);
				cprintf("MP: %i/%i/%i/%i",Player1.hp,Player2.hp,Player3.hp,Player4.hp);
				gotoxy(5,24);
				cprintf("Gold: $%i",User.gold);
				gotoxy(33,24);
				cprintf("Press ESC for Menu");

				gotoxy(User.x,User.y);
				textcolor(4);
				textbackground(0);
				cprintf("@");

/*				while(!kbhit())
				{
				}
				*/
				keytemp=getch();
				keytemp=toupper(keytemp);
				switch(keytemp)
				{
				case 27:  //handles the ESC key
/*					Quit=1;
					_setcursortype(_NORMALCURSOR);
					ShowMainMenu();
					Status=MAINMENU;              */
					CurrentMap="SETUP1.DAT";
					Status=SHOWSETUPMENU;
					break;
				case 'F': //fight scene
					CurrentMap="FIGHT1.DAT";
					Status=SHOWFIGHT;
					break;
				case 'S': //setup menu
					CurrentMap="SETUP1.DAT";
					Status=SHOWSETUPMENU;
					break;
				case 'N':  //Sets walking on air on or off
					if(NoClipping==0)
					{
						NoClipping=1;
						gotoxy(5,25);
						cprintf("              ");
						gotoxy(5,25);
						cprintf("Walk On Air");
					}
					else if(NoClipping==1)
					{
						NoClipping=0;
						gotoxy(5,25);
						cprintf("Walk On Ground");
					}
					break;
				case 'M': //Little temporary cheat thingy...goes to any map
					int tempXcoord=0;
					int tempYcoord=0;
					gotoxy(35,21);
					cprintf("X Coordinate: ");
					cscanf("%i",&tempXcoord);
					gotoxy(35,22);
					cprintf("Y Coordinate: ");
					cscanf("%i",&tempYcoord);
					gotoxy(35,21);
					printf("               ");
					gotoxy(35,22);
					printf("               ");
					CurrentPage.x=tempXcoord;
					CurrentPage.y=tempYcoord;
					sprintf(CurrentMap,"MAP%i%i.DAT",CurrentPage.x,CurrentPage.y);
					LoadMap(CurrentMap);
					DisplayMap();
					break;
				case 0:  //trap the extended character set (for arrow keys)
					keytemp=getch();
					switch(keytemp)
					{
						case 'P':  //down arrow key
							if(NoClipping==1)
							{
								ColorCode((Map[User.y-1][User.x-1]),User.x,User.y);
								User.y++;
							}
							else if(Map[User.y][User.x-1]=='l')
							{                  //Don't even ask about the User.x and
								ColorCode((Map[User.y-1][User.x-1]),User.x,User.y);
								User.y++;       //User.y offsets...they are just because
							}                  //of certain problems in compatibility with Map[y][x]
							else if(Map[User.y][User.x-1]=='u')
							{
								ColorCode((Map[User.y-1][User.x-1]),User.x,User.y);
								User.y++;
							}
							else if(Map[User.y][User.x-1]=='A')
							{
								User.y++;
								sprintf(CurrentMap,"00%i%i%i%i.CAS",CurrentPage.x,CurrentPage.y,User.x,User.y);
								LoadMap(CurrentMap);
								DisplayMap();
								CurrentPage.oldx=CurrentPage.x;
								CurrentPage.oldy=CurrentPage.y;
								User.oldx=User.x;
								User.oldy=User.y;
								User.x=2;
								User.y=10;
								Status=TOWN;
							}
							else if(Map[User.y][User.x-1]=='T')
							{
								User.y++;
								sprintf(CurrentMap,"00%i%i%i%i.TWN",CurrentPage.x,CurrentPage.y,User.x,User.y);
								LoadMap(CurrentMap);
								DisplayMap();
								CurrentPage.oldx=CurrentPage.x;
								CurrentPage.oldy=CurrentPage.y;
								User.oldx=User.x;
								User.oldy=User.y;
								User.x=2;
								User.y=10;
								Status=TOWN;
							}
							else if(Map[User.y][User.x-1]=='#')
							{
								sprintf(CurrentMap,"MAP%i%i.DAT",CurrentPage.oldx,CurrentPage.oldy);
								LoadMap(CurrentMap);
								DisplayMap();
								CurrentPage.x=CurrentPage.oldx;
								CurrentPage.y=CurrentPage.oldy;
								User.x=User.oldx;
								User.y=User.oldy;
								Status=MAINMAP;
							}
							else if(Map[User.y][User.x-1]=='S')
							{
								CurrentPage.y++;
								sprintf(CurrentMap,"MAP%i%i.DAT",CurrentPage.x,CurrentPage.y);
								LoadMap(CurrentMap);
								DisplayMap();
								User.y=2;
							}
							else
							{
								break;
							}
							break;
						case 'H': //up arrow key
							if(NoClipping==1)
							{
								ColorCode((Map[User.y-1][User.x-1]),User.x,User.y);
								User.y--;
							}
							else if(Map[User.y-2][User.x-1]=='l')
							{
								ColorCode((Map[User.y-1][User.x-1]),User.x,User.y);
								User.y--;
							}
							else if(Map[User.y-2][User.x-1]=='u')
							{
								ColorCode((Map[User.y-1][User.x-1]),User.x,User.y);
								User.y--;
							}
							else if(Map[User.y-2][User.x-1]=='A')
							{
								User.y--;
								sprintf(CurrentMap,"00%i%i%i%i.CAS",CurrentPage.x,CurrentPage.y,User.x,User.y);
								LoadMap(CurrentMap);
								DisplayMap();
								CurrentPage.oldx=CurrentPage.x;
								CurrentPage.oldy=CurrentPage.y;
								User.oldx=User.x;
								User.oldy=User.y;
								User.x=2;
								User.y=10;
								Status=TOWN;
							}
							else if(Map[User.y-2][User.x-1]=='T')
							{
								User.y--;
								sprintf(CurrentMap,"00%i%i%i%i.TWN",CurrentPage.x,CurrentPage.y,User.x,User.y);
								LoadMap(CurrentMap);
								DisplayMap();
								CurrentPage.oldx=CurrentPage.x;
								CurrentPage.oldy=CurrentPage.y;
								User.oldx=User.x;
								User.oldy=User.y;
								User.x=2;
								User.y=10;
								Status=TOWN;
							}
							else if(Map[User.y-2][User.x-1]=='#')
							{
								sprintf(CurrentMap,"MAP%i%i.DAT",CurrentPage.oldx,CurrentPage.oldy);
								LoadMap(CurrentMap);
								DisplayMap();
								CurrentPage.x=CurrentPage.oldx;
								CurrentPage.y=CurrentPage.oldy;
								User.x=User.oldx;
								User.y=User.oldy;
								Status=MAINMAP;
							}
							else if(Map[User.y-2][User.x-1]=='N')
							{
								CurrentPage.y--;
								sprintf(CurrentMap,"MAP%i%i.DAT",CurrentPage.x,CurrentPage.y);
								LoadMap(CurrentMap);
								DisplayMap();
								User.y=19;
							}
							else
							{
								break;
							}
							break;
						case 'M': //right arrow key
							if(NoClipping==1)
							{
								ColorCode((Map[User.y-1][User.x-1]),User.x,User.y);
								User.x++;
							}
							else if(Map[User.y-1][User.x]=='l')
							{
								ColorCode((Map[User.y-1][User.x-1]),User.x,User.y);
								User.x++;
							}
							else if(Map[User.y-1][User.x]=='u')
							{
								ColorCode((Map[User.y-1][User.x-1]),User.x,User.y);
								User.x++;
							}
							else if(Map[User.y-1][User.x]=='A')
							{
								User.x++;
								sprintf(CurrentMap,"00%i%i%i%i.CAS",CurrentPage.x,CurrentPage.y,User.x,User.y);
								LoadMap(CurrentMap);
								DisplayMap();
								CurrentPage.oldx=CurrentPage.x;
								CurrentPage.oldy=CurrentPage.y;
								User.oldx=User.x;
								User.oldy=User.y;
								User.x=2;
								User.y=10;
								Status=TOWN;
							}
							else if(Map[User.y-1][User.x]=='T')
							{
								User.x++;
								sprintf(CurrentMap,"00%i%i%i%i.TWN",CurrentPage.x,CurrentPage.y,User.x,User.y);
								LoadMap(CurrentMap);
								DisplayMap();
								CurrentPage.oldx=CurrentPage.x;
								CurrentPage.oldy=CurrentPage.y;
								User.oldx=User.x;
								User.oldy=User.y;
								User.x=2;
								User.y=10;
								Status=TOWN;
							}
							else if(Map[User.y-1][User.x]=='#')
							{
								sprintf(CurrentMap,"MAP%i%i.DAT",CurrentPage.oldx,CurrentPage.oldy);
								LoadMap(CurrentMap);
								DisplayMap();
								CurrentPage.x=CurrentPage.oldx;
								CurrentPage.y=CurrentPage.oldy;
								User.x=User.oldx;
								User.y=User.oldy;
								Status=MAINMAP;
							}

							else if(Map[User.y-1][User.x]=='E')
							{
								CurrentPage.x++;
								sprintf(CurrentMap,"MAP%i%i.DAT",CurrentPage.x,CurrentPage.y);
								LoadMap(CurrentMap);
								DisplayMap();
								User.x=2;
							}
							else
							{
								break;
							}
							break;
						case 'K': //left arrow key
							if(NoClipping==1)
							{
								ColorCode((Map[User.y-1][User.x-1]),User.x,User.y);
								User.x--;
							}
							else if(Map[User.y-1][User.x-2]=='l')
							{
								ColorCode((Map[User.y-1][User.x-1]),User.x,User.y);
								User.x--;
							}
							else if(Map[User.y-1][User.x-2]=='u')
							{
								ColorCode((Map[User.y-1][User.x-1]),User.x,User.y);
								User.x--;
							}
							else if(Map[User.y-1][User.x-2]=='A')
							{
								User.x--;
								sprintf(CurrentMap,"00%i%i%i%i.CAS",CurrentPage.x,CurrentPage.y,User.x,User.y);
								LoadMap(CurrentMap);
								DisplayMap();
								CurrentPage.oldx=CurrentPage.x;
								CurrentPage.oldy=CurrentPage.y;
								User.oldx=User.x;
								User.oldy=User.y;
								User.x=2;
								User.y=10;
								Status=TOWN;
							}
							else if(Map[User.y-1][User.x-2]=='T')
							{
								User.x--;
								sprintf(CurrentMap,"00%i%i%i%i.TWN",CurrentPage.x,CurrentPage.y,User.x,User.y);
								LoadMap(CurrentMap);
								DisplayMap();
								CurrentPage.oldx=CurrentPage.x;
								CurrentPage.oldy=CurrentPage.y;
								User.oldx=User.x;
								User.oldy=User.y;
								User.x=2;
								User.y=10;
								Status=TOWN;
							}

							else if(Map[User.y-1][User.x-2]=='#')
							{
								sprintf(CurrentMap,"MAP%i%i.DAT",CurrentPage.oldx,CurrentPage.oldy);
								LoadMap(CurrentMap);
								DisplayMap();
								CurrentPage.x=CurrentPage.oldx;
								CurrentPage.y=CurrentPage.oldy;
								User.x=User.oldx;
								User.y=User.oldy;
								Status=MAINMAP;
							}

							else if(Map[User.y-1][User.x-2]=='W')
							{
								CurrentPage.x--;
								sprintf(CurrentMap,"MAP%i%i.DAT",CurrentPage.x,CurrentPage.y);
								LoadMap(CurrentMap);
								DisplayMap();
								User.x=79;
							}
							else
							{
								break;
							}
							break;
					}
				}
				break;
			case MAINMENU:
				while(!kbhit())  //wait until the user presses a key
				{
				}
				keytemp=getch();  //get the key pressed into a variable
				keytemp=toupper(keytemp); //turn the key pressed into uppercase
				switch(keytemp)
				{
				case 27:  //handles the ESC key
					Quit=1;
					_setcursortype(_NORMALCURSOR);
					break;
				case 13:  //handles the enter key
					switch(MainMenuKeyStatus)
					{
					case 0: //this is the new game button
						Status=SHOWMAINMAP;
						break;
					case 2: //This is the Show Intro button
						ShowIntroduction();
						ShowMainMenu();
						break;
					case 3: //This is the Show Credits button
						ShowCredits();
						ShowMainMenu();
						break;
					case 4: //this is the Exit Game Button
						Quit=1;  //quits the game promptly :)
						break;
					}
					break;
				case 0:  //trap the extended character set (for arrow keys)
					keytemp=getch();
					switch(keytemp)
					{
						case 'P':  //down arrow key
							if(MainMenuKeyStatus<4)
							{
								MainMenuKeyStatus=MainMenuKeyStatus++;
								gotoxy(28,12+MainMenuKeyStatus);
							}
							break;
						case 'H': //up arrow key
							if(MainMenuKeyStatus>0)
							{
								MainMenuKeyStatus=MainMenuKeyStatus--;
								gotoxy(28,12+MainMenuKeyStatus);
							}
							break;
					}
			}
		};
	};
return(0);
};


//-=-=-=-=-=-=-=-=-=-=-=-=-=-=- ShowLogoScreen -=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//shows my logo screen
void ShowLogoScreen()
{

_setcursortype(_NOCURSOR);

	int temp;  //our little temp variable

	clrscr();  //clears the screen

	textcolor(7);
	for(temp=1;temp<45;temp++)
	{
		gotoxy(1,5);
		cprintf("                                                                              ");
		gotoxy(temp,5);
		WaitForVsync();
		cprintf("F i n a l   F a n t a s y   Z e r o\r\n\n");
		delay(20);
	}


	textcolor(2);
	gotoxy(1,1);     //Displays the version number for normal build
	cprintf("v.13 Pre-Alpha");


/*
	textcolor(2);
	gotoxy(1,1);     //Displays the version number for in progress build
	cprintf("v.13 Pre-Alpha (In-Progress Build)");
	gotoxy(1,2);
	cprintf("Please get the newest version as soon as possible");
*/

	textcolor(8);
	for(temp=1;temp<63;temp++)
	{
		gotoxy(1,7);
		cprintf("                                                                              ");
		gotoxy(temp,7);
		WaitForVsync();
		cprintf("Text Mode Version\r\n");
		delay(20);
	}

	textcolor(9);
	for(temp=1;temp<55;temp++)
	{
		gotoxy(1,8);
		cprintf("                                                                              ");
		gotoxy(temp,8);
		WaitForVsync();
		cprintf("Created by: Justin Heiner\r\n");
		delay(20);
	}

	textcolor(12);
	gotoxy(31,20);
	cprintf("Press Any Key");
	while(!kbhit())  //wait until the user presses a key
	{
	}
	getch(); //throw away what the user pressed

};

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=- ShowMainMenu -=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//Displays the main menu
void ShowMainMenu()
{
_setcursortype(_NOCURSOR);
textbackground(0);
textcolor(3);
clrscr();
gotoxy(1,1);
cprintf("      ____|_)             |   ____|           |                    __  /\r\n");
cprintf("      |     | __ \\   _` | |   |    _` | __ \\  __| _` |  __| |   |     /\r\n");
cprintf("      __|   | | | | (   | |   __| (   | | | | |  (   |\\__ \\ |   |    /\r\n");
cprintf("     _|    _|_| |_|\\__,_|_|  _|  \\__,_|_| |_|\\__\\__,_|____/\\__, |  ____|\r\n");
cprintf("                                                           ____/\r\n");

textcolor(4);
cprintf("                                                            /$\r\n");
cprintf("                                                                  by: ArdDisk\r\n");


gotoxy(27,12);
textcolor(9);
cprintf("+-=N");
textcolor(7);
cprintf("ew Game=----------+");

gotoxy(27,13);
textcolor(9);
cprintf("+-=L");
textcolor(7);
cprintf("oad Game=---------+");

gotoxy(27,14);
textcolor(9);
cprintf("+-=S");
textcolor(7);
cprintf("how Introduction=-+");

gotoxy(27,15);
textcolor(9);
cprintf("+-=S");
textcolor(7);
cprintf("how Credits=------+");

gotoxy(27,16);
textcolor(9);
cprintf("+-=E");
textcolor(7);
cprintf("xit Game=---------+");

gotoxy(28,12); //positions the cursor over the first menu selection


}

//-=-=-=-=-=-=-=-=-=-=-=-=-=- ShowCredits -=-=-=-=-=-=-=-=-=-=-=-=-=-
//shows who made this wonderful game :)
void ShowCredits()
{
_setcursortype(_NOCURSOR);

clrscr();
textcolor(7);
gotoxy(34,2);
cprintf("CREDITS");
gotoxy(21,10);
textcolor(3);
cprintf("Programming:");
textcolor(2);
cprintf("          MeRWiN");
gotoxy(21,11);
textcolor(3);
cprintf("  ASCII Art:");
textcolor(2);
cprintf("          HardDisk/MeRWiN");
gotoxy(21,12);
textcolor(3);
cprintf("      Sound:");
textcolor(2);
cprintf("          What sound?");
gotoxy(16,22);
textcolor(9);
cprintf("Based on the Final Fantasy games by SquareSoft");

while(!kbhit())  //wait until the user presses a key
{
}
getch(); //throw away what the user pressed
MainMenuKeyStatus=0;

}

//-=-=-=-=-=-=-=-=-=-=-=-=-=- ShowIntroduction -=-=-=-=-=-=-=-=-=-=-=-=-=-
//displays the introduction story
void ShowIntroduction()
{
_setcursortype(_NOCURSOR);

int StopDaLooping=0;
char *str1;
char intro[20][80];
clrscr();
gotoxy(1,2);

str1="         In 1927, the world had been turned into a wasteland due to a\r\n";
strcpy(&intro[0][0],str1);
str1="       massive world war greater than any other war that had ever been\r\n";
strcpy(&intro[1][0],str1);
str1="      experienced in the past.  All of the nations of the world had been\r\n";
strcpy(&intro[2][0],str1);
str1="         devistated and in dire need of food and supplies to rebuild\r\n";
strcpy(&intro[3][0],str1);
str1="            and attempt to restart their countries and their lives.\r\n\n";
strcpy(&intro[4][0],str1);
str1="          Germany, the only country to come out of this war unscathed,\r\n";
strcpy(&intro[5][0],str1);
str1="         built huge factories around the world and created a worldwide\r\n";
strcpy(&intro[6][0],str1);
str1="          military which was led by a man by the name of Adolf Hitler.\r\n\n";
strcpy(&intro[7][0],str1);
str1="         Hitler set up more than 500 concentration camps in the former\r\n";
strcpy(&intro[8][0],str1);
str1="           United States alone.  Hitler's rule continued to increase\r\n";
strcpy(&intro[9][0],str1);
str1="               until he and his troops dominated the entire world.\r\n\n";
strcpy(&intro[10][0],str1);
str1="        Three hundred years have passed since Hitler took control over\r\n";
strcpy(&intro[11][0],str1);
str1="         the world.  Cities had been rebuilt, technology was at a peak,\r\n";
strcpy(&intro[12][0],str1);
str1="                and life was, for the most part, very pleasant.\r\n\n";
strcpy(&intro[13][0],str1);
str1="        Four young men, hearing stories of the past freedom, decided to\r\n";
strcpy(&intro[14][0],str1);
str1="         create a revolt throughout the world so as to bring the world\r\n";
strcpy(&intro[15][0],str1);
str1="                      back to its former and divided self.\r\n\n";
strcpy(&intro[16][0],str1);
str1="                         And here the story begins...\r\n";
strcpy(&intro[17][0],str1);

	textbackground(9);
	clrscr();
	WaitForVsync();
	gotoxy(1,2);
	for(int temp=0;temp<=17 && StopDaLooping==0;temp++)
	{
		for(int temp2=0;temp2<160 && StopDaLooping==0;temp2+=20)
		{
			int temp4=wherex();
			int temp3=wherey();
			if(!kbhit())  //if the user hasn't hit a key, do all the rest of this stuff.
			{
				delay(temp2);
				printf("%s",&intro[temp][0]);
				delay(temp2);
				gotoxy(temp4,temp3);
				delline();
			}
			else
				StopDaLooping=1;  //if the user presses a key, it exits out of the loop prematurely (sp?)
		}

		printf("%s",&intro[temp][0]);
	}


while(!kbhit())  //wait until the user presses a key
{
}
getch(); //throw away what the user pressed
textbackground(0);
clrscr();
MainMenuKeyStatus=0;
}

//-=-=-=-=-=-=-=-=-=-=-=-=-=- ColorCode -=-=-=-=-=-=-=-=-=-=-=-=-
void ColorCode(char tempchar, int x, int y)
{
char finalchar; //final character to come out of the color coding

		switch(tempchar)   //My color coding system.  l=land
		{                  //                         u=forest
		case 'l':          //                         ~=water (water will cover from where you put it to the nearest object)
			textcolor(10);  //                         `=Black space
			textbackground(0); //                      =move south one map
			finalchar='';    //                       =move north one map
			break;           //                        =move east one map
		case 'u':           //                   		 =move west one map
			textcolor(2);  //                 			 t=mountains
			textbackground(0);  //                  =town
			finalchar='';  //                      =castle
			break;          //                      =cave
		case 't':				//								#=exits out of a town/cave/etc.
			textcolor(6);
			textbackground(0);
			finalchar='';
			break;
		case 'N':  //north
			textcolor(8);
			textbackground(0);
			finalchar='';
			break;
		case 'E':  //east or west
			textcolor(8);
			textbackground(0);
			finalchar='';
			break;
		case 'W':  //east or west
			textcolor(8);
			textbackground(0);
			finalchar='';
			break;
		case 'C':  //cave
			textcolor(1);
			textbackground(7);
			finalchar='';
			break;
		case 'A':  //castle
			textcolor(4);
			textbackground(7);
			finalchar='';
			break;
		case 'T':  //town
			textcolor(1);
			textbackground(7);
			finalchar='';
			break;
		case 'S':   //south
			textcolor(8);
			textbackground(0);
			finalchar='';
			break;
		case '-':
			textcolor(8);
			textbackground(0);
			finalchar='=';
			break;
		case 'O':
			textcolor(6);
			textbackground(0);
			finalchar='O';
			break;
		case '#':  //exits out of a town/cave/etc.
			textcolor(7);
			textbackground(0);
			finalchar='#';
			break;
		case '~':
			textcolor(1);
			textbackground(1);
			finalchar=' ';
			break;
		case '`':
			textcolor(0);
			textbackground(0);
			finalchar='`';
			break;
		default:
			textcolor(1);      //This makes it so you don't have to keep putting
			textbackground(1); //~'s for water.
		}
		gotoxy(x,y);
		cprintf("%c",finalchar);

}


//-=-=-=-=-=-=-=-=-=-=-=-=-=- LoadMap -=-=-=-=-=-=-=-=-=-=-=-=-=-
//Loads a map
void LoadMap(char *Filename)
{
FILE* oFile;
if ((oFile= fopen(Filename, "rt"))  == NULL)  //Opens the file MAP.DAT
{
	fprintf(stderr, "Cannot open input file.\n");
}
fread(&Map,sizeof(Map),1,oFile);     //Read the entire map into the structfclose(oFile);
fclose(oFile);

}


//-=-=-=-=-=-=-=-=-=-=-=-=-=- DisplayMap -=-=-=-=-=-=-=-=-=-=-=-=-=-
void DisplayMap()
{
_setcursortype(_NOCURSOR);
gotoxy(1,1);
int tempx=0;  //temp x variable
int tempy=0;  //temp y variable
char tempchar; //holds the temp character for the color coding
char finalchar; //final character to come out of the color coding

for(tempy=0;tempy<20;tempy++)     //\
	{                              // \
	gotoxy(0,tempy);               //  \ These just print the characters in
	for(tempx=0;tempx<80;tempx++)  //  / the order that it should be displayed
		{                           // /  on the map
		tempchar=Map[tempy][tempx]; ///
		ColorCode((Map[tempy][tempx]),tempx+1,tempy+1);  //sends everything to be color coded
		}
	}
}
